<?php
/*
    Charles Rincheval aka hugo
    http://www.digitalspirit.org/
 */

define('VIDEO_PATH', './vid.avi');
define('THUMB_SIZE_WIDTH', 100);
define('THUMB_SIZE_HEIGHT', 74);
define('THUMB_TOTAL', 50);

$mov = new ffmpeg_movie(VIDEO_PATH);

if (isset($_GET['frame'])) {
    $frame = $mov->getFrame($_GET['frame']);
    $frame->resize(THUMB_SIZE_WIDTH, THUMB_SIZE_HEIGHT);
    $img = $frame->toGDImage();
    header("Content-type: image/jpeg");
    imagejpeg($img);
    exit();
}

echo '<h1>Creating thumb for '.VIDEO_PATH.'</h1>';

echo '<p>Original : <a href="'.VIDEO_PATH.'">'.VIDEO_PATH.'</a></p>';

echo sprintf('<p>Duration : %.1f, bit rate : %d, frame count : %d, video codec : %s, audio codec : %s, audio channel : %s</p>',
                $mov->getDuration(),
                $mov->getBitRate(),
                $mov->getFrameCount(),
                $mov->getVideoCodec(),
                $mov->getAudioCodec(),
                $mov->getAudioChannels());

$gif = new ffmpeg_animated_gif('out.gif', THUMB_SIZE_WIDTH, THUMB_SIZE_HEIGHT, 5, 0);

$inc = round($mov->getFrameCount() / THUMB_TOTAL);
for ($i = 1; $i < $mov->getFrameCount(); $i += $inc) {
    echo '<img src="?frame='.$i.'" alt="Frame '.$i.'" />'."\n";

    $frame = $mov->getFrame($i);
    $gif->addFrame($frame);
}

echo '<p>Gif export : </p><img src="out.gif" alt="Output to gif" />';

?>
